#include <stm32f0xx.h>
#include <stdlib.h>
#include <string.h>

volatile uint32_t t_fl=0,sec = 0,sec_fl = 0,T2tic = 0,Stop = 0;
volatile signed int Tcount = 0,PWMset = 0;
volatile uint16_t ADC_buff[3],m_en = 1,c_en= 0,Sp_mes_buf[10],Sp_Mes_Ptr = 0,Sp_Mes_Sum,Sp_Mes = 0;
char recive_buf[40],text[40],transmite_buf[60];
uint8_t recive_ptr = 0,recive_fl = 0,key_dir = 0,key_usart_en = 1,key_null_det = 0;
uint16_t Sp_Set = 0,I_Mes = 0;
void SysTick_Handler(void)
	{
		t_fl = 1;
		if (++sec > 99) sec = 0,sec_fl = 1;
	};

void init_gpio(void)
	{
		RCC->AHBENR|=RCC_AHBENR_GPIOAEN;
		RCC->AHBENR|=RCC_AHBENR_GPIOBEN;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER0;		//Tim2_ch1 ROTATE SENSOR
		GPIOA->MODER |= GPIO_MODER_MODER0_1;		
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR0;  
		GPIOA->BSRR = GPIO_BSRR_BR_0;				
		GPIOA->AFR[0] |= 0x00000002;			
		
		//GPIOA->MODER |=  GPIO_MODER_MODER1;			//SET torque
		
		GPIOA->MODER &=~  GPIO_MODER_MODER1;		//PMOS1
		GPIOA->MODER |= GPIO_MODER_MODER1_0;
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_1;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR1;   
		GPIOA->BSRR = GPIO_BSRR_BR_1;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER2;		//Uart TX
		GPIOA->MODER |= GPIO_MODER_MODER2_1;		
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_2;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR2;
		GPIOA->AFR[0] |= 0x00000100;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER3;		//Uart RX
		GPIOA->MODER |= GPIO_MODER_MODER3_1;		
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_3;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR3;
		GPIOA->AFR[0] |= 0x00001000;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER4;		//SET dir
		
		GPIOA->MODER |=  GPIO_MODER_MODER5;			//MesI
		
		GPIOA->MODER |=  GPIO_MODER_MODER6;			//SET speed

		GPIOA->MODER &=~  GPIO_MODER_MODER7;		//PMOS1
		GPIOA->MODER |= GPIO_MODER_MODER7_0;
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_7;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR7;   
		GPIOA->BSRR = GPIO_BSRR_BR_7;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER9;		//NMOS1
		GPIOA->MODER |= GPIO_MODER_MODER9_1;		
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_9;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR9;
		GPIOA->AFR[1] |= 0x00000020;
		
		GPIOA->MODER &=~  GPIO_MODER_MODER10;		//NMOS2
		GPIOA->MODER |= GPIO_MODER_MODER10_1;		
		GPIOA->OTYPER &=~ GPIO_OTYPER_OT_10;			
		GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR10;
		GPIOA->AFR[1] |= 0x00000200;
		/*
		GPIOA->MODER &=~  GPIO_MODER_MODER13;		//Uart Enable
		GPIOA->PUPDR |= GPIO_PUPDR_PUPDR13_0;		//PULL UP
		
		GPIOA->MODER &=~  GPIO_MODER_MODER14;		//NULL detect
		GPIOA->PUPDR |= GPIO_PUPDR_PUPDR14_0;		//PULL UP
*/
		GPIOB->MODER &=~  GPIO_MODER_MODER1;		//Tim1_ch4 buzzer
		GPIOB->MODER |= GPIO_MODER_MODER1_0;
		GPIOB->OTYPER &=~ GPIO_OTYPER_OT_1;	
		GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR1;  
		GPIOB->BSRR = GPIO_BSRR_BR_1;							
};
void USART1_Init(void)
{
   //RCC->APB2ENR |=   RCC_APB2ENR_AFIOEN; 
	RCC->APB2ENR |=   RCC_APB2ENR_USART1EN;
	RCC->CFGR3     &= ~RCC_CFGR3_USART1SW;
  RCC->CFGR3     |=  RCC_CFGR3_USART1SW_0;  //System clock (SYSCLK) selected as USART1 clock
                 
  USART1->BRR   =   0x1A73;                // 9600 b/s to 65MHz
  USART1->CR1  &=  ~USART_CR1_M;                       
  USART1->CR2  &=  ~USART_CR2_STOP;                   
  USART1->CR1  |=   USART_CR1_UE;                     
  USART1->CR1  |=   USART_CR1_TE;                      
  USART1->CR1  |=   USART_CR1_RE; 	 	
};

void USART1_SendData(unsigned char data)
{
	while(!(USART1->ISR & USART_ISR_TC)){};
  USART1->TDR = data;                              
};

void USART1_SendString(char *str)
{
	unsigned char i;
	for (i=0;i<strlen(str);i++)
	{
		USART1_SendData(str[i]);
	};
	USART1_SendData(13);USART1_SendData(10);
};

void USART1_ReciveData(void)
{
	char us_tmp;
	if (USART1->ISR & USART_ISR_RXNE) 
	{
		us_tmp = USART1->RDR;
		if ((us_tmp == 0x0d) || (us_tmp == 0x0a))
		{	
			recive_buf[recive_ptr] = 0;
			if (us_tmp == 0x0a) recive_ptr = 0;
			recive_fl = 1;
		} else {	
		recive_buf[recive_ptr] = us_tmp;
		recive_ptr++;
		};
  };	
};

void init_tim1(void)
	{
	RCC->APB2ENR |= RCC_APB2ENR_TIM1EN;           
	TIM1->CR1 |= TIM_CR1_ARPE;
	TIM1->CR2 |= TIM_CR2_OIS2 | TIM_CR2_OIS3;
	TIM1->CCMR1 |= TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;	
	TIM1->CCMR1 |= TIM_CCMR1_OC2FE;	
	TIM1->CCMR2 |= TIM_CCMR2_OC3M_2 | TIM_CCMR2_OC3M_1;	
	TIM1->CCMR2 |= TIM_CCMR2_OC3FE;
	TIM1->CCER |= TIM_CCER_CC2E | TIM_CCER_CC3E;
	TIM1->PSC = 64;			
	TIM1->ARR = 1000-1;	
	TIM1->CCR2 = 0;		
	TIM1->CCR3 = 0;	
	TIM1->BDTR |= TIM_BDTR_MOE;
	TIM1->CR1 |= TIM_CR1_CEN;	
	};

void init_tim2(void)
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;
	TIM2->PSC = 13;	//5mhz
	TIM2->ARR = 10000000;	//2sec
	TIM2->CNT = 0;
	TIM2->DIER |= TIM_DIER_UIE;
	NVIC_EnableIRQ(TIM2_IRQn);
	TIM2->CR1 |= TIM_CR1_CEN;	
};
void TIM2_IRQHandler(void)
{
	TIM2->SR = 0;
	Stop = 1;
	T2tic = 0;
};
/*
	T2tic = TIM2->CCR1;TIM2->CNT = 0;
	if (Sp_Mes_Sum) Sp_Mes_Sum = Sp_Mes_Sum - Sp_mes_buf[Sp_Mes_Ptr];
	Sp_mes_buf[Sp_Mes_Ptr] = T2tic;
	Sp_Mes_Sum = Sp_Mes_Sum + Sp_mes_buf[Sp_Mes_Ptr];
	if (++Sp_Mes_Ptr > 9) Sp_Mes_Ptr = 0;
	Sp_Mes = Sp_Mes_Sum / 10;
	if (key_dir) Tcount--; else Tcount++;
	if (GPIOA->ODR & 0x2) GPIOA->BSRR = GPIO_BSRR_BR_1; else GPIOA->BSRR = GPIO_BSRR_BS_1;
*/
void init_adc(void)
{
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN; 
	RCC->CR2 |= RCC_CR2_HSI14ON; 
	while ((RCC->CR2 & RCC_CR2_HSI14RDY) == 0)   {  };
	if ((ADC1->CR & ADC_CR_ADEN) != 0) 
		{
		ADC1->CR &= (uint32_t)(~ADC_CR_ADEN);  
		}
	ADC1->CR |= ADC_CR_ADCAL; 
	while ((ADC1->CR & ADC_CR_ADCAL) != 0)   {  };  
	__NOP();__NOP();   
	//ADC1->CFGR1 |= ADC_CFGR1_AUTOFF;
	ADC1->CFGR1 |= ADC_CFGR1_CONT;
	ADC1->CHSELR = ADC_CHSELR_CHSEL1 | ADC_CHSELR_CHSEL5 | ADC_CHSELR_CHSEL6;
	ADC1->SMPR = 0x07; 

	RCC->AHBENR |= RCC_AHBENR_DMA1EN; 
	ADC1->CFGR1 |= ADC_CFGR1_DMAEN | ADC_CFGR1_DMACFG;

	ADC1->CR |= ADC_CR_ADEN; 
	
	DMA1_Channel1->CPAR = (uint32_t) (&(ADC1->DR)); 
	DMA1_Channel1->CMAR = (uint32_t)(ADC_buff); 
	DMA1_Channel1->CNDTR = 3; 
	DMA1_Channel1->CCR |= DMA_CCR_MINC | DMA_CCR_MSIZE_0 | DMA_CCR_PSIZE_0 | DMA_CCR_TEIE | DMA_CCR_CIRC; 
	DMA1_Channel1->CCR |= DMA_CCR_EN; 

	ADC1->CR |= ADC_CR_ADSTART; // start the ADC conversions 
	};

void reverse(char s[])
 {
 int i, j;
 char c;
 for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
 c = s[i];
 s[i] = s[j];
 s[j] = c;
 }
 };
 
void itoa(int n, char s[])
 {
 int i, sign;
 if ((sign = n) < 0) //?????????? ???? 
 n = -n; // ?????? n ????????????? ?????? 
 i = 0;
 do { //?????????? ????? ? ???????? ??????? 
 s[i++] = n % 10 + '0'; //????? ????????? ????? 
 } while ((n /= 10) > 0); // ??????? 
 if (sign < 0)
 s[i++] = '-';
 s[i] = '\0';
 reverse(s);
 };

void EXTI0_1_IRQHandler (void)
	{
		
		T2tic = TIM2->CNT;
		TIM2->CNT = 0;
		if (key_dir) Tcount--; else Tcount++;
		if (GPIOA->ODR & 0x2) GPIOA->BSRR = GPIO_BSRR_BR_1; else GPIOA->BSRR = GPIO_BSRR_BS_1;
		EXTI->PR |= EXTI_PR_PR0;
	};
int main(void)
{	
	RCC->CR |= RCC_CR_HSEON;
	while (!(RCC->CR & RCC_CR_HSERDY)) {};
	FLASH->ACR |= FLASH_ACR_PRFTBE;
	FLASH->ACR |= FLASH_ACR_LATENCY;	
	RCC->CFGR |= RCC_CFGR_PLLSRC_HSE_PREDIV;
	RCC->CFGR |= RCC_CFGR_PLLXTPRE;
	RCC->CFGR2 = (4-1);								// 	26/4
	RCC->CFGR |= (10-2)<<18; 					/// Xtall/4*10=65
	RCC->CR |= RCC_CR_PLLON;
	while (!(RCC->CR & RCC_CR_PLLRDY)) {}; 
	RCC->CFGR |= RCC_CFGR_SW_PLL;
	RCC->CFGR |= RCC_CFGR_HPRE_DIV1;    
	RCC->CFGR |= RCC_CFGR_PPRE_DIV1;
	RCC->APB2ENR |= RCC_APB2ENR_SYSCFGEN;
	init_gpio();
	init_adc();
	USART1_Init();
	init_tim1();
	init_tim2();
	SysTick_Config(650000); // 0.01 sek	
	EXTI->RTSR |= EXTI_RTSR_TR0;
	EXTI->IMR |= EXTI_IMR_MR0;	
	NVIC_EnableIRQ (EXTI0_1_IRQn);
		while(1)
	{
		
		USART1_ReciveData();
		if(recive_fl)
			{
			recive_fl = 0;
			if(strcmp(recive_buf,"AT") == 0) recive_buf[0] = 0,USART1_SendString("AT OK!");
			if(strcmp(recive_buf,"AT+STOP") == 0) m_en = 0,recive_buf[0] = 0,USART1_SendString("MOTOR OFF");
			if(strcmp(recive_buf,"AT+RUN") == 0) m_en= 1,recive_buf[0] = 0,USART1_SendString("MOTOR ON");	
			if(strcmp(recive_buf,"AT+PCDR") == 0) c_en= 1,m_en = 0,recive_buf[0] = 0,USART1_SendString("PC DRIVE ON");
			if(strcmp(recive_buf,"AT+MANDR") == 0) c_en= 0,m_en = 1,recive_buf[0] = 0,USART1_SendString("MANUAL DRIVE ON");				
			};
			
		if (c_en == 0) Sp_Set = (ADC_buff[2]*18)>>5; else Sp_Set = (ADC_buff[2]*18)>>7;	//Zadanie Skorosti 0-2000 ob/min
		I_Mes = (ADC_buff[1]*11)>>2;			
		if (T2tic) Sp_Mes = 37500000/T2tic; else Sp_Mes = 0;	//Izmerenie Skorosti
			
		if (t_fl) 
		{
			t_fl = 0;
			key_dir = (~GPIOA->IDR & 0x10)>>4;	//napravlenie
			//key_usart_en = (~GPIOA->IDR & 0x2000)>>13;
			//key_null_det = (~GPIOA->IDR & 0x4000)>>14;
					
		if (Sp_Set > Sp_Mes) PWMset = PWMset + 1 + ((Sp_Set - Sp_Mes)>>5); //Formula Regulatora
											else PWMset = PWMset - ((Sp_Mes - Sp_Set)>>5); 
					
		if (PWMset > 1000) PWMset = 1000;	//Granitci
		if (PWMset < 0) PWMset = 0;
			
			if (m_en) {		//esli vkl
			if (key_dir) 	//napravlenie 
			{
				GPIOA->BSRR = GPIO_BSRR_BR_7;TIM1->CCR3 = 0;TIM1->CCR2 = PWMset;GPIOB->BSRR = GPIO_BSRR_BS_1;
			} else {
				GPIOB->BSRR = GPIO_BSRR_BR_1;TIM1->CCR2 = 0;TIM1->CCR3 = PWMset;GPIOA->BSRR = GPIO_BSRR_BS_7;
			};
		} else { //esli vikl
			GPIOA->BSRR = GPIO_BSRR_BR_7;TIM1->CCR3 = 0;GPIOB->BSRR = GPIO_BSRR_BR_1;TIM1->CCR2 = 0;
			PWMset = 0;
		};
		};
		if (sec_fl)	//vivod v COM port
		{
			sec_fl = 0;
			itoa(Sp_Set,text);USART1_SendString(text);
			itoa(Sp_Mes,text);USART1_SendString(text);
			itoa(I_Mes,text);USART1_SendString(text);
			itoa(Tcount,text);USART1_SendString(text);
		};
	};
}

